#include    "E2_lib.h"

#define     NBG1_CEL_ADR    (VDP2_VRAM_A1 + 0x00000)
#define     NBG1_COL_ADR    (VDP2_COLRAM  + 0x00200)

void ss_main(void)
{
 int type_of_peripheral;
 int temp1 = 0;

 slInitSystem(TV_320x240, IMAGE2D_texture, 2);
 slPrint("E2SR1A - Example 01:", slLocate(2, 3));
 slPrint("VirtuaGun Program", slLocate(2, 4));
 e2_BACKCOLOR_setup(0, 0, 0);
 e2_SOUND_initialize(2);
 e2_VIRTUAGUN_initialize();

 e2_IMAGE2D_32K_load_from_CDROM(0, "bullet_h.txt"); slPrint("IMG 32K #01:  Okay!!", slLocate(2, 7));
 e2_SPRITE2D_32K_BASIC_reallocate(1);
 e2_SPRITE2D_32K_BASIC_setup(0, NO, 0, toFIXED(0.0), toFIXED(0.0), toFIXED(200.0), DEGtoANG(0.0), toFIXED(1.0), NO, YES, toFIXED(-160.0), toFIXED(160.0), toFIXED(-120.0), toFIXED(120.0), toFIXED(100.0), toFIXED(400.0));
 for(temp1 = 0; temp1 != 1; temp1++)
  e2_IMAGE2D_32K_load_into_SPRITEVRAM(temp1, IMAGE2D_memory_address, 0);
 e2_IMAGE2D_setup(1);

 slColRAMMode(CRM16_1024);
 e2_IMAGE2D_PAL_load_from_CDROM(0, "calib.txt"  );  slPrint("BMP 256 #02:  Okay!!", slLocate(2, 9));
 e2_PALETTE2D_load_from_CDROM(  0, "calib_p.txt");  slPrint("PAL 256 #03:  Okay!!", slLocate(2, 10));

 e2_PALETTE2D_load_into_COLORRAM(0, NBG1_COL_ADR, 256);
 e2_BITMAP2D_setup(0, 1, 0, 0, 1, 0, NBG1_CEL_ADR);
 slScrPosNbg1(toFIXED(0.0), toFIXED(0.0));
 slScrTransparent(NBG1ON);
 slScrAutoDisp(NBG0ON | NBG1ON);

 e2_SOUND_PCM_load_from_CDROM(  0, "shoot_fx.txt"); slPrint("PCM SFX #04:  Okay!!", slLocate(2, 12));
 slSndVolume(127);

 type_of_peripheral = e2_PERIPHERAL_check_whats_connected(CONTROLPORT_1);
 while(type_of_peripheral != PERIPHERAL_VIRTUAGUN)
 {
  slPrint("Please connect a VIRTUAGUN to 1P port.", slLocate(2, 5));
  type_of_peripheral = e2_PERIPHERAL_check_whats_connected(CONTROLPORT_1);
  slSynch();
 }
 slPrint("                                      ", slLocate(2, 5));

 e2_VIRTUAGUN_calibrate(VIRTUAGUN_1, 320, 240);
 slPrintFX(VIRTUAGUN_data[VIRTUAGUN_1][3], slLocate(20, 7));
 slPrintFX(VIRTUAGUN_data[VIRTUAGUN_1][4], slLocate(20, 8));
 slPrintFX(VIRTUAGUN_data[VIRTUAGUN_1][5], slLocate(20, 10));
 slPrintFX(VIRTUAGUN_data[VIRTUAGUN_1][6], slLocate(20, 11));
 slPrintFX(VIRTUAGUN_data[VIRTUAGUN_1][7], slLocate(20, 13));
 slPrintFX(VIRTUAGUN_data[VIRTUAGUN_1][8], slLocate(20, 14));

 while(TRUE)
 {
  type_of_peripheral = e2_PERIPHERAL_check_whats_connected(CONTROLPORT_1);
  while(type_of_peripheral != PERIPHERAL_VIRTUAGUN)
  {
   slPrint("Please connect a VIRTUAGUN to 1P port.", slLocate(2, 5));
   type_of_peripheral = e2_PERIPHERAL_check_whats_connected(CONTROLPORT_1);
   slSynch();
  }
  slPrint("                                       ", slLocate(2, 5));

  e2_VIRTUAGUN_check(VIRTUAGUN_1);
  if(VIRTUAGUN_data[VIRTUAGUN_1][VIRTUAGUN_button] == VIRTUAGUN_t_button)
  {
   slPrint("[Buttons Pressed]:  TRIGGER.          ", slLocate(2, 5));
   pSPRITE2D_32K_BASIC[0].show_sprite = YES;
   pSPRITE2D_32K_BASIC[0].position[X] = VIRTUAGUN_data[VIRTUAGUN_1][VIRTUAGUN_x_position];
   pSPRITE2D_32K_BASIC[0].position[Y] = VIRTUAGUN_data[VIRTUAGUN_1][VIRTUAGUN_y_position];
   e2_SOUND_PCM_stop_and_play(0);
   while(VIRTUAGUN_data[VIRTUAGUN_1][VIRTUAGUN_button] == VIRTUAGUN_t_button){e2_VIRTUAGUN_check(VIRTUAGUN_1);   e2_SPRITE2D_32K_BASIC_animate(0); slSynch();}   // While trigger is pulled.
  }
  if(VIRTUAGUN_data[VIRTUAGUN_1][VIRTUAGUN_button] == VIRTUAGUN_s_button)
   slPrint("[Buttons Pressed]:  START.            ", slLocate(2, 5));
  if(VIRTUAGUN_data[VIRTUAGUN_1][VIRTUAGUN_button] == VIRTUAGUN_s_and_t_buttons)
  {
   slPrint("[Buttons Pressed]:  TRIGGER & START.  ", slLocate(2, 5));
   pSPRITE2D_32K_BASIC[0].show_sprite = YES;
   pSPRITE2D_32K_BASIC[0].position[X] = VIRTUAGUN_data[VIRTUAGUN_1][VIRTUAGUN_x_position];
   pSPRITE2D_32K_BASIC[0].position[Y] = VIRTUAGUN_data[VIRTUAGUN_1][VIRTUAGUN_y_position];
   e2_SOUND_PCM_stop_and_play(0);
   while(VIRTUAGUN_data[VIRTUAGUN_1][VIRTUAGUN_button] == VIRTUAGUN_s_and_t_buttons){e2_VIRTUAGUN_check(VIRTUAGUN_1);   e2_SPRITE2D_32K_BASIC_animate(0); slSynch();}   // While trigger is pulled.
  }
  if(VIRTUAGUN_data[VIRTUAGUN_1][VIRTUAGUN_button] != VIRTUAGUN_t_button &&
     VIRTUAGUN_data[VIRTUAGUN_1][VIRTUAGUN_button] != VIRTUAGUN_s_button &&
     VIRTUAGUN_data[VIRTUAGUN_1][VIRTUAGUN_button] != VIRTUAGUN_s_and_t_buttons)
   slPrint("[Buttons Pressed]:  NONE.             ", slLocate(2, 5));

  e2_SPRITE2D_32K_BASIC_animate(0);
  slSynch();
 }
}
